/**
 * スイカとかオイスターカードとかのプリペイド型電車切符． 演習1の出題時点の知識のみでやってみる感じ．
 * ex1aバージョンと変化なし．
 * 
 * @author kaiya
 * 
 */
public class Card {
	/**
	 * カードが記憶している前払い運賃の総額
	 */
	private int balance = 0;

	/**
	 * 先払い運賃を得る
	 * 
	 * @return 先払いしている運賃
	 */
	public int getBalance() {
		return balance;
	}

	/**
	 * 乗った駅，乗車前および下車後はnullである．
	 */
	private Station station = null;

	/**
	 * 前払いする金額を継ぎ足す． 日本語でチャージと言われる行為．
	 * 
	 * @param c
	 *            継ぎ足す金額，0未満の数の場合無視される．
	 */
	public void topUp(int c) {
		if (c > 0) {
			balance += c;
		}
	}

	/**
	 * 乗車する．
	 * 
	 * @param s
	 *            乗車した駅, もしすでに乗車中なら乗車できない．
	 */
	public void getOn(Station s) {
		if (station != null)
			return; // 本来，乗車状態で再度乗車するのだから例外を上げるべき．
		this.station = s;
	}

	/**
	 * 下車し，決済する． 運賃が払えなければ下車できない． すなわち，改札を通れない．
	 * 
	 * @param s
	 *            下車する駅
	 * @return 決済できればtrue, そうでなければ false
	 */
	public boolean getOff(Station s) {
		int f = s.getFareFrom(station);
		if (f < 0)
			return false; // 到達不能な駅間だから本来は例外を上げるべき．
		if (balance >= f) {
			balance -= f;
			station = null;
			return true;
		} else {
			return false;
		}
	}
}
