import java.util.HashMap;

/**
 * 駅．変更あり． 素直に連想配列(ハッシュ)を利用．
 * 
 * @author kaiya
 * 
 */
public class Station {
	/**
	 * 駅の名前
	 */
	private String name;

	/**
	 * 名前を返す
	 * 
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * インスタンス生成時に駅名をセット
	 * 
	 * @param n
	 *            駅名
	 */
	public Station(String n) {
		name = n;
	}

	/**
	 * s駅からこの駅までの運賃を帰す
	 * 
	 * @param s
	 *            基点の駅
	 * @return 運賃，到達不能や基点がnullなら 負の数を返す．
	 */
	public int getFareFrom(Station s) {
		Integer i = fareMap.get(s);
		if (s == null)
			return -1;
		// return i.intValue();
		return i; // auto-boxing があるんでコレでOK，上記じゃなくてよい．
	}

	private HashMap<Station, Integer> fareMap = new HashMap<Station, Integer>();

	/**
	 * 駅sからココまでの運賃情報を登録．
	 * 
	 * @param s
	 *            登録する始点駅 特にnullとかのチェックはしません．
	 * @param f
	 *            sからココまでの運賃 特に正数であるチェックとかしません．
	 */
	void addFareInfo(Station s, int f) {
		fareMap.put(s, f);
	}
}
